; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
ANTIALIASED_QUALITY = 4
xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
GLYPHMETRICSFLOAT STRUCT
	gmfBlackBoxX dd ?
	gmfBlackBoxY dd ?
	x	     dd ?
	y	     dd ?
	gmfCellIncX  dd ?
	gmfCellIncY  dd ?
GLYPHMETRICSFLOAT ENDS

GMFSIZE EQU SIZEOF GLYPHMETRICSFLOAT
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
        je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	c1:dword
local	c2:dword
local	c3:dword
local	c4:qword
local	buffer[50]:byte
local	font:dword
local	oldfont:dword
local	len:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,_Font_List
	invoke	glDeleteLists,,256
	mov	ecx,gmf
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:movaps	xmm0,rot
	addps	xmm0,delta
	movaps	rot,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,GMFSIZE*256
	mov	gmf,eax
;-------------------------------------------------------
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movd	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; 0.0f,0.0f,0.0f,0.5
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
        invoke	glEnable,GL_LIGHT0
 	invoke	glEnable,GL_LIGHTING
 	invoke	glEnable,GL_COLOR_MATERIAL
; Create the outline font
	invoke	glGenLists,256	; Create storage for 256 Characters
	mov	_Font_List,eax
	pushaddr aFontName
	push	DEFAULT_PITCH or FF_DONTCARE	;Family And Pitch
	push	ANTIALIASED_QUALITY		;Output Quality
	push	CLIP_DEFAULT_PRECIS		;Clipping Precision
	push	OUT_TT_PRECIS			;Output Precision
	push	ANSI_CHARSET			;Character Set Identifier
	push	rbx                             ;Strikeout
	push	rbx                             ;Underline
	push	rbx                             ;Italic
	push	FW_BOLD                         ;Font Weight
	sub	esp,20h
	mov	ecx,-12;Height
	invoke	CreateFont,,0,0,0;,Width,Angle Of Escapement,Orientation Angle
	mov	font,eax
	invoke	SelectObject,hDC,eax
        mov	oldfont,eax
	mov	eax,gmf
	mov	[rsp+38h],rax
	mov	r9d,_Font_List
	mov	eax,const0_2
        invoke	wglUseFontOutlinesA,hDC,0,255,,rbx,rax,WGL_FONT_POLYGONS
	mov	edx,oldfont
	invoke	SelectObject,hDC
	mov	ecx,font
	invoke	DeleteObject
	
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity
	movd	xmm6,const1

	xorps	xmm2,xmm2
	subss	xmm2,const10
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTranslatef

	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xrot
        invoke	glRotatef

	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	movss	xmm0,yrot
        invoke	glRotatef

	movss	xmm3,xmm6
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,zrot
        invoke	glRotatef

	movss	xmm0,rot
	divss	xmm0,const20
	invoke	cosf
	movss	c1,xmm0
	movss	xmm0,xrot
	divss	xmm0,const25
	invoke	sinf
	movss	c2,xmm0
	movss	xmm0,xrot
	divss	xmm0,const17
	invoke	cosf
	mulss	xmm0,const0_5
	movss	xmm2,xmm6
	subss	xmm2,xmm0	
	movss	xmm1,c2
	movss	xmm0,c1
	invoke	glColor3f 

	movss	xmm0,xrot
	divss	xmm0,const50
	cvtss2sd xmm0,xmm0
	movq	c4,xmm0	
	lea	r8d,c4
	mov	edx,offset fmt
	lea	ecx,buffer
	invoke	vsprintf
	mov	len,eax
	dec	eax
	xorps	xmm1,xmm1
	mov	esi,eax;len
        lea	eax,buffer
	mov	edx,gmf
@@:	movzx	ecx,byte ptr [rsi+rax]
	imul	ecx,GMFSIZE
	addss	xmm1,[rdx+rcx].GLYPHMETRICSFLOAT.gmfCellIncX
	dec	esi
	jns	@b
	mulss	xmm1,const0_5
	xorps	xmm0,xmm0
	subss	xmm0,xmm1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	invoke	glTranslatef
;---------------------------------------
	invoke	glPushAttrib,GL_LIST_BIT 
	mov	ecx,_Font_List
    	invoke	glListBase
	lea	r8d,buffer
	mov	ecx,len
	invoke	glCallLists,,GL_UNSIGNED_BYTE
	invoke	glPopAttrib
;---------------------------------------------	
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #14 - Outline Fonts",0
FileName	db "br_Rabbit3.cur",0
aFontName	db "Comic Sans MS",0; "Times New Roman",0;
_Font_List	dd ?; Font base
fmt		db "NeHe - %3.2f",0
gmf		dd ?;GLYPHMETRICSFLOAT 256 dup (<>)
;-----------------------------
;float
const0_2	dd 0.2
const0_5	dd 0.5
const1		dd 1.0
const1_4	dd 1.4
const1_5	dd 1.5
const10		dd 10.0
const17		dd 17.0
const20		dd 20.0
const25		dd 25.0
const50		dd 50.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
rot		dd 0,0,0,0
delta		dd 0.5,0.75,0.7,0
end